"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Serializer {
    constructor(serializable, options = {}) {
        this.serializable = serializable;
        this.options = options;
    }
    toJSON() {
        if (this.serializable instanceof Array) {
            return this.serializable.map(record => record.serialize());
        }
        let data;
        try {
            data = this.serializable.serializerAttributes();
        }
        catch (err) {
            if (err.name === 'TypeError') {
                return this.serializable.toJSON();
            }
            throw err;
        }
        if (this.options.exclude) {
            for (const attr of this.options.exclude) {
                delete data[attr];
            }
        }
        return data;
    }
    // TODO: Is this even accessible anymore?
    get length() {
        let results = 1;
        if (this.serializable instanceof Array) {
            results = this.serializable.length;
        }
        return results;
    }
}
exports.Serializer = Serializer;
function serialize(options) {
    return new Serializer(this, options).toJSON();
}
exports.serialize = serialize;
//# sourceMappingURL=index.js.map